﻿using System;
using System.Collections.Generic;
using System.Web;

namespace GeneGeneradorFacturaLib
{
    /// <summary>
    /// Asistente para el trabajo con los tipos de datos enumerados.
    /// </summary>
    public static class AsistenteEnum
    {
        /// <summary>
        /// Obtiene la descripción para mostrar de un valor de un tipo de dato enumerado.
        /// </summary>
        /// <param name="tipoenum">Tipo del enummerado</param>
        /// <param name="valor">Valor al cual se le va a obtener la descripción.</param>
        /// <returns>Descripción del valor</returns>
        public static string ObtenerDescripcion(Type tipoenum, string valor)
        {
            string resultado = "n";
            if (typeof(DocumentoDTE.SiiDte.Enumerations.Referencia_CodRef) == tipoenum)
            {
                switch (valor)
                {
                    case "1": resultado = "Anula Documento de Referencia";
                        break;
                    case "2": resultado = "Corrige Texto del Documento de Referencia";
                        break;
                    case "3": resultado = "Corrige Montos";
                        break;
                }
            }
            else
                if (typeof(DocumentoDTE.SiiDte.Enumerations.IdDoc_TipoDespacho) == tipoenum)
                {
                    switch (valor)
                    {
                        case "1": resultado = "Despacho por Cuenta del Comprador";
                            break;
                        case "2": resultado = "Despacho por Cuenta del Emisor a Instalaciones del Comprador";
                            break;
                        case "3": resultado = "Despacho por Cuenta del Emisor a Otras Instalaciones";
                            break;
                    }
                }
                else if (typeof(DocumentoDTE.SiiDte.Enumerations.MedioPagoType) == tipoenum)
                {
                    switch (valor)
                    {
                        case "CH": resultado = "Cheque";
                            break;
                        case "LT": resultado = "Letra";
                            break;
                        case "EF": resultado = "Efectivo";
                            break;
                        case "PE": resultado = "Pago a Cuenta Corriente";
                            break;
                        case "TC": resultado = "Tarjeta de Credito";
                            break;
                        case "CF": resultado = "Cheque a Fecha";
                            break;
                        case "OT": resultado = "Otro";
                            break;
                    }

                }
                else
                    if (typeof(DocumentoDTE.SiiDte.Enumerations.IdDoc_IndTraslado) == tipoenum)
                    {
                        switch (valor)
                        {
                            case "1": resultado = "Operacion Constituye Venta";
                                break;
                            case "2": resultado = "Venta por Efectuar";
                                break;
                            case "3": resultado = "Consignacion";
                                break;
                            case "4": resultado = "Promocion  o Donacion";
                                break;
                            case "5": resultado = "Traslado Interno";
                                break;
                            case "6": resultado = "Otros Traslados que no Constituyen Venta";
                                break;
                            case "7": resultado = "Guia de Devolucion";
                                break;
                            case "8": resultado = "Traslado para exportación.(no venta)";
                                break;
                            case "9": resultado = "Venta para exportación";
                                break;
                        }
                    }
                    else
                        if (typeof(DocumentoDTE.SiiDte.Enumerations.ImpAdicDTEType) == tipoenum)
                        {
                            switch (valor)
                            {
                                case "14": resultado = "IVA Margen Comercializacion"; break;
                                case "15": resultado = "IVA Retenido Total"; break;
                                case "16": resultado = "IVA Retenido Parcial"; break;
                                case "17": resultado = "IVA Anticipado Faenamiento Carne"; break;
                                case "18": resultado = "IVA Anticipado Carne"; break;
                                case "19": resultado = "IVA Anticipado Harina"; break;
                                case "23": resultado = "Impuesto Adicional Productos Art. 37 a) b) c)  Oro, Joyas, Pieles"; break;
                                case "24": resultado = "Impuesto Art. 42 a) Licores, Pisco, Destilados"; break;
                                case "25": resultado = "Impuesto Art. 42 c) Vinos"; break;
                                case "26": resultado = "Impuesto Art. 42 c) Cervezas y Bebidas Alcoholicas"; break;
                                case "27": resultado = "Impuesto Art. 42 d) y e) Bebidas Analcoholicas y Minerales"; break;
                                case "28": resultado = "Impuesto Especifico Diesel"; break;
                                case "30": resultado = "IVA Retenido Legumbres"; break;
                                case "31": resultado = "IVA Retenido Silvestres"; break;
                                case "32": resultado = "IVA Retenido Ganado"; break;
                                case "33": resultado = "IVA Retenido Madera"; break;
                                case "34": resultado = "IVA Retenido Trigo"; break;
                                case "35": resultado = "Impuesto Especifico Gasolina"; break;
                                case "36": resultado = "IVA Retenido Arroz"; break;
                                case "37": resultado = "IVA Retenido Hidrobiologicas"; break;
                                case "38": resultado = "IVA Retenido Chatarra"; break;
                                case "39": resultado = "IVA Retenido PPA"; break;
                                case "40": resultado = "IVA Retenido Opcional"; break;
                                case "41": resultado = "IVA Retenido Construccion"; break;
                                case "44": resultado = "Impuesto Adicional Productos Art. 37 e) h) i) l)  1ra Venta (Alfombras, C. Rodantes, Caviar, Armas)"; break;
                                case "45": resultado = "Impuesto Adicional Productos Art. 37 j)  1ra Venta (Pirotecnia)"; break;
                                default: resultado = valor;
                                    break;

                            }
                        }
                        else
                            if (typeof(DocumentoDTE.SiiDte.Enumerations.MedioPagoType) == tipoenum)
                            {
                                switch (valor)
                                {
                                    case "CH": resultado = "Cheque";
                                        break;
                                    case "LT": resultado = "Letra";
                                        break;
                                    case "EF": resultado = "Efectivo";
                                        break;
                                    case "PE": resultado = "Pago a Cuenta Corriente";
                                        break;
                                    case "TC": resultado = "Tarjeta de Credito";
                                        break;
                                    case "CF": resultado = "Cheque a Fecha";
                                        break;
                                    case "OT": resultado = "Otro";
                                        break;
                                }

                            }
                            else
                                if (typeof(DocumentoDTE.SiiDte.Enumerations.DetalleB_IndExe) == tipoenum)
                                {
                                    switch (valor)
                                    {
                                        case "1": resultado = "El Producto o Servicio NO ESTA Afecto a IVA";
                                            break;
                                        case "2": resultado = "El Producto o Servicio NO ES Facturable";
                                            break;
                                        case "3": resultado = "Garantia por Deposito/Envase";
                                            break;
                                        case "4": resultado = "El producto No Constituye Venta";
                                            break;
                                        case "5": resultado = "Item a Rebajar";
                                            break;
                                        case "6": resultado = "No facturables negativos";
                                            break;
                                    }

                                }
                                else
                                    if (typeof(DocumentoDTE.SiiDte.Enumerations.Detalle_IndExe) == tipoenum)
                                    {
                                        switch (valor)
                                        {
                                            case "1": resultado = "El Producto o Servicio NO ESTA Afecto a IVA";
                                                break;
                                            case "2": resultado = "El Producto o Servicio NO ES Facturable";
                                                break;
                                            case "3": resultado = "Garantia por Deposito/Envase";
                                                break;
                                            case "4": resultado = "El producto No Constituye Venta";
                                                break;
                                            case "5": resultado = "Item a Rebajar";
                                                break;
                                            case "6": resultado = "No facturables negativos";
                                                break;
                                        }

                                    }
                                    else
                                        if (typeof(DocumentoDTE.SiiDte.Enumerations.DetalleA_IndExe) == tipoenum)
                                        {
                                            switch (valor)
                                            {
                                                case "1": resultado = "El Producto o Servicio NO ESTA Afecto a IVA";
                                                    break;
                                                case "2": resultado = "El Producto o Servicio NO ES Facturable";
                                                    break;
                                                case "3": resultado = "Garantia por Deposito/Envase";
                                                    break;
                                                case "4": resultado = "El producto No Constituye Venta";
                                                    break;
                                                case "5": resultado = "Item a Rebajar";
                                                    break;
                                                case "6": resultado = "No facturables negativos";
                                                    break;
                                            }

                                        }
                                        else
                                            if (typeof(DocumentoBoleta.SiiDte.Enumerations.Detalle_IndExe) == tipoenum)
                                            {
                                                switch (valor)
                                                {
                                                    case "1": resultado = "Producto o Servicio es Exento o No Afecto";
                                                        break;
                                                    case "2": resultado = "El Producto o Servicio NO ES Facturable";
                                                        break;
                                                }
                                            }
            return resultado;
        }

        /// <summary>
        /// Obtiene una lista con los tipos de documentos.
        /// </summary>
        /// <returns>Lista de objetos KeyValuePair<string, string> (código, nombre) que representan los tipos de documentos.</returns>
        public static List<KeyValuePair<string, string>> ListaTipoDocumento()
        {
            var resultado = new List<KeyValuePair<string, string>>();
            resultado.Add(new KeyValuePair<string, string>("33", "Factura Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("34", "Factura No Afecta o Exenta Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("39", "Boleta Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("41", "Boleta Exenta Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("43", "Liquidación-Factura Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("46", "Factura de Compra Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("52", "Guía de Despacho Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("56", "Nota de Débito Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("61", "Nota de Crédito Electrónica"));
            resultado.Add(new KeyValuePair<string, string>("110", "Factura de Exportación"));
            resultado.Add(new KeyValuePair<string, string>("111", "Nota de Débito de Exportación"));
            resultado.Add(new KeyValuePair<string, string>("112", "Nota de Crédito de Exportación"));
            return resultado;
        }

        /// <summary>
        /// Obtiene una lista con las unidades de medida.
        /// </summary>
        /// <returns>Lista de objetos KeyValuePair<string, string> (sigla, nombre) que representan las unidades de medida.</returns>
        public static List<KeyValuePair<string, string>> ListaUnidadMedida()
        {
            var resultado = new List<KeyValuePair<string, string>>();
            resultado.Add(new KeyValuePair<string, string>("und", "Unidad"));
            resultado.Add(new KeyValuePair<string, string>("t", "Tonelada"));
            resultado.Add(new KeyValuePair<string, string>("kg", "Kilogramo"));
            resultado.Add(new KeyValuePair<string, string>("lb", "Libra"));
            resultado.Add(new KeyValuePair<string, string>("g", "Gramo"));
            resultado.Add(new KeyValuePair<string, string>("oz", "Onza"));
            resultado.Add(new KeyValuePair<string, string>("km", "Kilometro"));
            resultado.Add(new KeyValuePair<string, string>("m", "Metro"));
            resultado.Add(new KeyValuePair<string, string>("cm", "Centimetro"));
            return resultado;
        }

    }
}