﻿using System;
using System.Collections.Generic;

namespace GenerarFactura
{
    /// <summary>
    /// Clase para definir las reglas de validación a realizar a un campo en la interfaz de usuario.
    /// </summary>
    public class Validacion
    {
        /// <summary>
        /// Label del campo, se usa en el mensaje mostrado al usuario al ocurrir un error de validación.
        /// </summary>
        public string LabelCampo { get; set; }
        /// <summary>
        /// Sección de la interfaz de usuario en la que se encuentra el campo. Esto permite realizar validaciones por secciones.
        /// </summary>
        public string Seccion { get; set; }
        /// <summary>
        /// Reglas de validación a aplicar al campo.
        /// Ejemplo: Reglas = new Dictionary<string, object> { {"req", true}, {"rut", true} }}}
        /// Reglas = new Dictionary<string, object> { {"req", true}, {"num", true}, {"min", new decimal(0.000001)} }
        /// req: requerido
        /// num: numérico
        /// min: valor mínimo
        /// </summary>
        public Dictionary<string, object> Reglas { get; set; }
    }
}
